program Demo;
uses Vga, VgaGl, VgaNormalKeyboard;

{$ignore-function-results}
{$L bitmap.o}

procedure LogoTest; asmname 'logotest';

{$define vgamode G320x200x256}

var
  ScanColors: PByteA;
  txt: String[255];
  Bmp: Pointer; (* For linuxlogo.bmp *)
  ScaledBmp: Pointer;
  h: Integer;

begin
  if not VgaHasMode(vgamode) then
     begin
       Writeln(ParamStr(0), ': Mode ', VgaGetModeName(vgamode), ' not supported.');
       Halt(-1);
     end;

  VgaSetMode(vgamode);
  GlSetContextVga(vgamode);
  GlSetRGBPalette;
  KeyboardInit;

  VgaClear;
  (* Which is like GlClearScreen(0) *)

  (* Set text attributes *)
  GlSetFont(8,8,GlFont8x8);
  GlSetWriteMode(FONT_COMPRESSED + WRITEMODE_OVERWRITE);
  GlSetFontColors(1, VgaWhite);
  (* Done! *)

  txt := 'This is written by GlWrite()';
  GlWrite((320-GlTextWidth(txt)) div 2, 80, txt);
  txt := 'This is instead written by GlWriten() [so that this is not displayed]';
  GlWriten((320- (8*37)) div 2, 89, 37, txt);
  (* GlWriten stops just before the '[' *)

  txt := 'Press any key to begin... ';
  GlWrite((320-GlTextWidth(txt)) div 2, 108, txt);

  (* Restore text colours *)
  GlSetFontColors(0, VgaWhite);

  Randomize;

  WaitKey;

  VgaClear;

  txt := 'Random Pixels';
  repeat
    VgaSetColor(Random(VgaGetColors));
    VgaDrawPixel(Random(VgaGetXDim), Random(VgaGetYDim));
    GlWrite((320-GlTextWidth(txt)) div 2, 95, txt);
  until AnyKeyPressed;
  WaitKey;
  VgaClear;

  txt := 'Random Lines';
  repeat
    VgaSetColor(Random(VgaGetColors));
    VgaDrawLine(Random(VgaGetXDim), Random(VgaGetYDim), Random(VgaGetXDim), Random(VgaGetYDim));
    GlWrite((320-GlTextWidth(txt)) div 2, 95, txt);
  until AnyKeyPressed;
  WaitKey;
  VgaClear;


  txt := 'Random GL Pixels';
  repeat
    GlSetPixelRGB(Random(VgaGetXDim),
                  Random(VgaGetYDim),
                  Random(255),
                  Random(255),
                  Random(255));
    GlWrite((320-GlTextWidth(txt)) div 2, 95, txt);
  until AnyKeyPressed;
  WaitKey;
  GlClearScreen(Random(255));

  txt := 'Random GL Circles';
  repeat
    GlCircle(Random(VgaGetXDim),
             Random(VgaGetYDim),
             Random(10),
             Random(255));
    GlWrite((320-GlTextWidth(txt)) div 2, 95, txt);
  until AnyKeyPressed;
  WaitKey;

  LogoTest;

  WaitKey;
  GlClearScreen(0);
  GlSetRGBPalette;

  GlSetFontColors(1, VgaWhite);
  txt := 'That''s all I can code in few minutes';
  GlWrite((320-GlTextWidth(txt)) div 2, 95, txt);
  WaitKey;

  KeyboardClose;
  VgaSetMode(TEXT_MODE);
end.
